import * as React from 'react';
function getInnerText(node) {
    if (typeof node === 'number') {
        return node.toString();
    } else if (node) {
        var children = void 0;
        if (React.isValidElement(node)) {
            children = node.props.children;
        } else if (node instanceof Array) {
            children = node;
        }
        if (children) {
            return React.Children.map(children, function (child) {
                return getInnerText(child);
            }).join('');
        } else {
            return node.toString();
        }
    } else {
        return '';
    }
}
export default getInnerText;