/// <reference types="react" />
import * as React from 'react';
import { AbstractInputProps } from './Input';
export interface AutoSizeType {
    minRows?: number;
    maxRows?: number;
}
export interface TextAreaProps extends AbstractInputProps {
    autosize?: boolean | AutoSizeType;
    onPressEnter?: React.FormEventHandler<any>;
    autoFocus?: boolean;
}
export interface TextAreaState {
    textareaStyles?: React.CSSProperties;
    inputLength?: number;
    focused?: boolean;
}
export declare type HTMLTextareaProps = React.TextareaHTMLAttributes<HTMLTextAreaElement>;
export default class TextArea extends React.Component<TextAreaProps & HTMLTextareaProps, TextAreaState> {
    static defaultProps: {
        prefixCls: string;
        underline: boolean;
        showLengthInfo: boolean;
    };
    nextFrameActionId: number;
    state: {
        textareaStyles: {};
        inputLength: number;
        focused: boolean;
    };
    private textAreaRef;
    componentDidMount(): void;
    componentWillReceiveProps(nextProps: TextAreaProps): void;
    focus(): void;
    blur(): void;
    resizeTextarea: () => void;
    getTextAreaClassName(): any;
    handleTextareaChange: (e: React.ChangeEvent<HTMLTextAreaElement>) => void;
    handleKeyDown: (e: React.KeyboardEvent<HTMLTextAreaElement>) => void;
    handleInput: () => void;
    saveTextAreaRef: (textArea: HTMLTextAreaElement) => void;
    getWapperClassName(): any;
    handleFocus: (e: React.FocusEvent<HTMLTextAreaElement>) => void;
    handleBlur: (e: React.FocusEvent<HTMLTextAreaElement>) => void;
    render(): JSX.Element;
}
