import _extends from 'babel-runtime/helpers/extends';
import _defineProperty from 'babel-runtime/helpers/defineProperty';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import * as React from 'react';
import classNames from 'classnames';
import Dialog from './Modal';
import Button from '../button';
import { getConfirmLocale } from './locale';

var Sidebar = function (_React$Component) {
    _inherits(Sidebar, _React$Component);

    function Sidebar(props) {
        _classCallCheck(this, Sidebar);

        var _this = _possibleConstructorReturn(this, (Sidebar.__proto__ || Object.getPrototypeOf(Sidebar)).call(this, props));

        _this.handleCancel = function (e) {
            var onCancel = _this.props.onCancel;
            if (onCancel) {
                onCancel(e);
            }
        };
        _this.handleOk = function (e) {
            var onOk = _this.props.onOk;
            if (onOk) {
                onOk(e);
            }
        };
        _this.renderFooter = function () {
            var props = _this.props;
            var prefixCls = props.prefixCls,
                onCancel = props.onCancel,
                onOk = props.onOk,
                okType = props.okType,
                funcType = props.funcType,
                confirmLoading = props.confirmLoading;

            var okCancel = 'okCancel' in props ? props.okCancel : true;
            var runtimeLocale = getConfirmLocale();
            var okText = props.okText || (okCancel ? runtimeLocale.okText : runtimeLocale.justOkText);
            var cancelText = props.cancelText || runtimeLocale.cancelText;
            var cancalBtn = okCancel ? React.createElement(
                Button,
                { className: prefixCls + '-btn-shanchux', disabled: confirmLoading, funcType: funcType, onClick: onCancel },
                cancelText
            ) : null;
            return React.createElement(
                'div',
                { className: prefixCls + '-btns' },
                React.createElement(
                    Button,
                    { className: prefixCls + '-btn-ok', loading: confirmLoading, funcType: funcType, type: okType, onClick: onOk },
                    okText
                ),
                cancalBtn
            );
        };
        _this.handleStatus = function () {
            var open = _this.state.open;

            _this.setState({
                open: !open
            });
        };
        _this.state = {
            open: false
        };
        return _this;
    }

    _createClass(Sidebar, [{
        key: 'render',
        value: function render() {
            var _classNames;

            var props = this.props;
            var prefixCls = props.prefixCls,
                zIndex = props.zIndex,
                visible = props.visible,
                keyboard = props.keyboard,
                footer = props.footer;
            var open = this.state.open;

            var classString = classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, prefixCls + '-sidebar', true), _defineProperty(_classNames, prefixCls + '-sidebar-open', open), _classNames), props.className);
            return React.createElement(
                Dialog,
                _extends({}, this.props, { animationEnd: this.handleStatus, width: props.width, className: classString, visible: visible, title: props.title, transitionName: props.transitionName, footer: footer === undefined ? this.renderFooter() : footer, zIndex: zIndex, keyboard: keyboard, closable: false }),
                this.props.children
            );
        }
    }]);

    return Sidebar;
}(React.Component);

export default Sidebar;

Sidebar.defaultProps = {
    prefixCls: 'ant-modal',
    width: '100%',
    transitionName: 'slide-right',
    maskTransitionName: 'fade',
    confirmLoading: false,
    visible: false,
    okType: 'primary',
    funcType: 'raised'
};