'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var React = _interopRequireWildcard(_react);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function getInnerText(node) {
    if (typeof node === 'number') {
        return node.toString();
    } else if (node) {
        var children = void 0;
        if (React.isValidElement(node)) {
            children = node.props.children;
        } else if (node instanceof Array) {
            children = node;
        }
        if (children) {
            return React.Children.map(children, function (child) {
                return getInnerText(child);
            }).join('');
        } else {
            return node.toString();
        }
    } else {
        return '';
    }
}
exports['default'] = getInnerText;
module.exports = exports['default'];