'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _icon = require('../icon');

var _icon2 = _interopRequireDefault(_icon);

var _select = require('../select');

var _select2 = _interopRequireDefault(_select);

var _pagination = require('../pagination');

var _pagination2 = _interopRequireDefault(_pagination);

var _tooltip = require('../tooltip');

var _tooltip2 = _interopRequireDefault(_tooltip);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _omit = require('omit.js');

var _omit2 = _interopRequireDefault(_omit);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var Option = _select2['default'].Option;
var icons = _icon2['default'].icons;

var IconSelect = function (_React$Component) {
    (0, _inherits3['default'])(IconSelect, _React$Component);

    function IconSelect(props) {
        (0, _classCallCheck3['default'])(this, IconSelect);

        var _this = (0, _possibleConstructorReturn3['default'])(this, (IconSelect.__proto__ || Object.getPrototypeOf(IconSelect)).call(this, props));

        _this.handleRender = function (label) {
            if (typeof label === 'string' && label) {
                return React.createElement(
                    'span',
                    null,
                    React.createElement(_icon2['default'], { type: label }),
                    ' ',
                    label
                );
            } else if ((typeof label === 'undefined' ? 'undefined' : (0, _typeof3['default'])(label)) === 'object' && label.props) {
                var children = label.props.children;

                return children ? React.cloneElement(React.createElement('span', null), {}, children) : null;
            } else {
                return null;
            }
        };
        _this.handlePageChange = function (current, pageSize) {
            var filterValue = _this.state.filterValue;

            _this.initIcon(current, pageSize, filterValue);
        };
        _this.handleFilter = function (value) {
            _this.initIcon(1, 20, value);
        };
        _this.saveRef = function (node) {
            if (node) {
                _this.rcSelect = node;
            }
        };
        _this.state = {
            current: 1,
            total: 0,
            pageSize: 20,
            filterValue: '',
            data: []
        };
        return _this;
    }

    (0, _createClass3['default'])(IconSelect, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.initIcon();
        }
    }, {
        key: 'initIcon',
        value: function initIcon() {
            var current = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
            var pageSize = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 20;
            var filterValue = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';

            var minIndex = (current - 1) * pageSize;
            var maxIndex = current * pageSize;
            var items = icons['default'];
            if (filterValue) {
                items = icons['default'].filter(function (name) {
                    return name.toLowerCase().indexOf(filterValue.toLowerCase()) !== -1;
                });
            }
            var total = items.length || 0;
            var currentData = items.filter(function (name, index) {
                return name && index >= minIndex && index < maxIndex;
            });
            this.setState({
                data: currentData,
                total: total,
                pageSize: pageSize,
                current: current,
                filterValue: filterValue
            });
        }
    }, {
        key: 'renderOption',
        value: function renderOption() {
            var data = this.state.data;

            return data.map(function (icon) {
                return React.createElement(
                    Option,
                    { key: icon, value: icon },
                    React.createElement(
                        _tooltip2['default'],
                        { placement: 'bottomLeft', title: icon },
                        React.createElement(_icon2['default'], { type: icon }),
                        ' ',
                        icon
                    )
                );
            });
        }
    }, {
        key: 'renderFooter',
        value: function renderFooter() {
            var _state = this.state,
                total = _state.total,
                pageSize = _state.pageSize,
                current = _state.current;

            return React.createElement(_pagination2['default'], { total: total, onChange: this.handlePageChange, pageSizeOptions: ['20', '40', '80'], pageSize: pageSize, onShowSizeChange: this.handlePageChange, current: current });
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                className = _props.className,
                prefix = _props.prefix,
                dropdownClassName = _props.dropdownClassName;

            var selectCls = (0, _classnames2['default'])(className, (0, _defineProperty3['default'])({}, '' + prefix, true));
            var dropDownCls = (0, _classnames2['default'])(dropdownClassName, (0, _defineProperty3['default'])({}, prefix + '-dropdown', true));
            var selectProps = (0, _extends3['default'])({}, this.props, { className: selectCls, dropdownClassName: dropDownCls });
            var otherProps = (0, _omit2['default'])(selectProps, ['prefix']);
            return React.createElement(
                _select2['default'],
                (0, _extends3['default'])({}, otherProps, { footer: this.renderFooter(), onFilterChange: this.handleFilter, filterValue: this.state.filterValue, choiceRender: this.handleRender, filter: true, ref: this.saveRef }),
                this.renderOption()
            );
        }
    }]);
    return IconSelect;
}(React.Component);

exports['default'] = IconSelect;

IconSelect.defaultProps = {
    prefix: 'ant-icon-select',
    filter: true,
    showArrow: false,
    showCheckAll: false
};
module.exports = exports['default'];