'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Modal = require('./Modal');

var _Modal2 = _interopRequireDefault(_Modal);

var _button = require('../button');

var _button2 = _interopRequireDefault(_button);

var _locale = require('./locale');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var Sidebar = function (_React$Component) {
    (0, _inherits3['default'])(Sidebar, _React$Component);

    function Sidebar(props) {
        (0, _classCallCheck3['default'])(this, Sidebar);

        var _this = (0, _possibleConstructorReturn3['default'])(this, (Sidebar.__proto__ || Object.getPrototypeOf(Sidebar)).call(this, props));

        _this.handleCancel = function (e) {
            var onCancel = _this.props.onCancel;
            if (onCancel) {
                onCancel(e);
            }
        };
        _this.handleOk = function (e) {
            var onOk = _this.props.onOk;
            if (onOk) {
                onOk(e);
            }
        };
        _this.renderFooter = function () {
            var props = _this.props;
            var prefixCls = props.prefixCls,
                onCancel = props.onCancel,
                onOk = props.onOk,
                okType = props.okType,
                funcType = props.funcType,
                confirmLoading = props.confirmLoading;

            var okCancel = 'okCancel' in props ? props.okCancel : true;
            var runtimeLocale = (0, _locale.getConfirmLocale)();
            var okText = props.okText || (okCancel ? runtimeLocale.okText : runtimeLocale.justOkText);
            var cancelText = props.cancelText || runtimeLocale.cancelText;
            var cancalBtn = okCancel ? React.createElement(
                _button2['default'],
                { className: prefixCls + '-btn-shanchux', disabled: confirmLoading, funcType: funcType, onClick: onCancel },
                cancelText
            ) : null;
            return React.createElement(
                'div',
                { className: prefixCls + '-btns' },
                React.createElement(
                    _button2['default'],
                    { className: prefixCls + '-btn-ok', loading: confirmLoading, funcType: funcType, type: okType, onClick: onOk },
                    okText
                ),
                cancalBtn
            );
        };
        _this.handleStatus = function () {
            var open = _this.state.open;

            _this.setState({
                open: !open
            });
        };
        _this.state = {
            open: false
        };
        return _this;
    }

    (0, _createClass3['default'])(Sidebar, [{
        key: 'render',
        value: function render() {
            var _classNames;

            var props = this.props;
            var prefixCls = props.prefixCls,
                zIndex = props.zIndex,
                visible = props.visible,
                keyboard = props.keyboard,
                footer = props.footer;
            var open = this.state.open;

            var classString = (0, _classnames2['default'])(prefixCls, (_classNames = {}, (0, _defineProperty3['default'])(_classNames, prefixCls + '-sidebar', true), (0, _defineProperty3['default'])(_classNames, prefixCls + '-sidebar-open', open), _classNames), props.className);
            return React.createElement(
                _Modal2['default'],
                (0, _extends3['default'])({}, this.props, { animationEnd: this.handleStatus, width: props.width, className: classString, visible: visible, title: props.title, transitionName: props.transitionName, footer: footer === undefined ? this.renderFooter() : footer, zIndex: zIndex, keyboard: keyboard, closable: false }),
                this.props.children
            );
        }
    }]);
    return Sidebar;
}(React.Component);

exports['default'] = Sidebar;

Sidebar.defaultProps = {
    prefixCls: 'ant-modal',
    width: '100%',
    transitionName: 'slide-right',
    maskTransitionName: 'fade',
    confirmLoading: false,
    visible: false,
    okType: 'primary',
    funcType: 'raised'
};
module.exports = exports['default'];