/// <reference types="react" />
import PropTypes from 'prop-types';
import * as React from 'react';
export interface ProgressProps {
    prefixCls?: string;
    className?: string;
    type?: 'line' | 'circle' | 'dashboard' | 'loading';
    percent?: number;
    successPercent?: number;
    format?: (percent: number) => string;
    status?: 'success' | 'active' | 'exception';
    showInfo?: boolean;
    strokeWidth?: number;
    trailColor?: string;
    width?: number;
    style?: React.CSSProperties;
    gapDegree?: number;
    gapPosition?: 'top' | 'bottom' | 'left' | 'right';
    size?: 'default' | 'small';
}
export default class Progress extends React.Component<ProgressProps, {}> {
    static Line: any;
    static Circle: any;
    static Loading: any;
    static defaultProps: {
        type: string;
        percent: number;
        showInfo: boolean;
        trailColor: string;
        prefixCls: string;
        size: string;
    };
    static propTypes: {
        status: PropTypes.Requireable<string>;
        type: PropTypes.Requireable<string>;
        showInfo: PropTypes.Requireable<boolean>;
        percent: PropTypes.Requireable<number>;
        width: PropTypes.Requireable<number>;
        strokeWidth: PropTypes.Requireable<number>;
        trailColor: PropTypes.Requireable<string>;
        format: PropTypes.Requireable<(...args: any[]) => any>;
        gapDegree: PropTypes.Requireable<number>;
        default: PropTypes.Requireable<string>;
    };
    render(): JSX.Element;
}
