'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _request2 = require('./request');

var _request3 = _interopRequireDefault(_request2);

var _requestget = require('./requestget');

var _requestget2 = _interopRequireDefault(_requestget);

var _requestpost = require('./requestpost');

var _requestpost2 = _interopRequireDefault(_requestpost);

var _uid = require('./uid');

var _uid2 = _interopRequireDefault(_uid);

var _attrAccept = require('./attr-accept');

var _attrAccept2 = _interopRequireDefault(_attrAccept);

var _jsMd = require('js-md5');

var _jsMd2 = _interopRequireDefault(_jsMd);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var AjaxUploader = function (_Component) {
  (0, _inherits3['default'])(AjaxUploader, _Component);

  function AjaxUploader() {
    var _temp, _this2, _ret;

    (0, _classCallCheck3['default'])(this, AjaxUploader);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this2 = (0, _possibleConstructorReturn3['default'])(this, _Component.call.apply(_Component, [this].concat(args))), _this2), _this2.state = {
      uid: (0, _uid2['default'])(),
      state: true,
      i: -1,
      fileData: '',
      uuidData: '',
      versionName: '',
      disabledInput: false
    }, _this2.reqs = {}, _this2.onChange = function (e) {
      if (_this2.state.i === -1) {
        var files = e.target.files;
        _this2.uploadFiles(files);
        _this2.reset();
      }
    }, _this2.onClick = function () {
      var el = _this2.fileInput;
      if (!el) {
        return;
      }
      el.click();
    }, _this2.onKeyDown = function (e) {
      if (e.key === 'Enter') {
        _this2.onClick();
      }
    }, _this2.onFileDrop = function (e) {
      if (e.type === 'dragover') {
        e.preventDefault();
        return;
      }
      var files = Array.prototype.slice.call(e.dataTransfer.files).filter(function (file) {
        return (0, _attrAccept2['default'])(file, _this2.props.accept);
      });
      _this2.uploadFiles(files);

      e.preventDefault();
    }, _this2.UploadSlice = function (file, uuid, versionName) {
      var _this3 = _this2,
          props = _this3.props;
      var _onProgress = props.onProgress;

      var requestpost = props.customRequest || _requestpost2['default'];
      var uid = file.uid;

      _this2.setState({
        fileData: file,
        uuidData: uuid,
        versionName: versionName,
        disabledInput: true
      });
      var _this = _this2;
      if (_this2.state.state) {
        var name = file.name; //文件名
        var size = file.size; //总大小
        var shardSize = 2 * 1024 * 1024; //以5MB为一个分片
        var shardCount = Math.ceil(size / shardSize); //总片数
        if (_this2.state.i >= shardCount) {
          _this2.setState({
            i: shardCount
          });
        } else {
          var ii = _this2.state.i + 1;
          _this2.setState({
            i: ii
          });
        }

        //计算每一片的起始与结束位置
        var start = _this2.state.i * shardSize;
        var end = Math.min(size, start + shardSize);

        //构造一个表单，FormData是HTML5新增的
        var form = new FormData();
        form.append("data", file.slice(start, end)); //slice方法用于切出文件的一部分]

        form.append("uuid", uuid);
        form.append("name", name);
        form.append("versionName", versionName);
        form.append("size", size);
        form.append("total", shardCount); //总片数
        form.append("index", _this2.state.i + 1); //当前是第几片

        var data = file.slice(start, end);
        var r = new FileReader();
        r.readAsBinaryString(data);
        if (!(_this2.state.i >= shardCount) && shardCount !== 1) {
          r.onload = function () {
            var props = _this.props;
            // _this.setState({
            //   removeUrl: props.actionDelete+`?fileName=${file.name}&uploadId=${uuid}`,
            // });

            _this.reqs[uid] = requestpost({
              action: props.actionUpload,
              filename: props.name,
              file: form.data,
              data: form,
              headers: props.headers,
              withCredentials: props.withCredentials,
              onProgress: function onProgress(e) {
                e.percent = e.percent / shardCount + 100 / shardCount * _this.state.i;
                _onProgress(e, file);
              },
              onSuccess: function onSuccess(res, xhr) {
                delete _this.reqs[uid];
                if (_this.state.i + 1 >= shardCount) {
                  // 全部上传完成
                  _this.setState({
                    i: -1,
                    fileData: '',
                    uuidData: '',
                    versionName: '',
                    disabledInput: false
                  });
                  props.onSuccess(res, file, xhr);
                } else {
                  //已上传成功,然后检测下一个分片
                  _this.setState({
                    progress: Math.floor((_this.state.i + 1) / shardCount * 100)
                  });
                  //递归调用                　
                  _this.UploadSlice(file, uuid, versionName);
                }
              },
              onError: function onError(err, ret) {
                _this.setState({
                  i: -1,
                  fileData: '',
                  uuidData: '',
                  versionName: '',
                  disabledInput: false
                });
                delete _this.reqs[uid];
                props.onError(err, ret, file);
              }
            });
          };
        }
      }
    }, _this2.saveFileInput = function (node) {
      _this2.fileInput = node;
    }, _temp), (0, _possibleConstructorReturn3['default'])(_this2, _ret);
  }

  AjaxUploader.prototype.componentDidMount = function componentDidMount() {
    this._isMounted = true;
  };

  AjaxUploader.prototype.componentWillUnmount = function componentWillUnmount() {
    this._isMounted = false;
    this.abort();
  };

  AjaxUploader.prototype.uploadFiles = function uploadFiles(files) {
    var _this4 = this;

    var postFiles = Array.prototype.slice.call(files);
    postFiles.forEach(function (file) {
      file.uid = (0, _uid2['default'])();
      _this4.upload(file, postFiles);
    });
  };

  AjaxUploader.prototype.upload = function upload(file, fileList) {
    var _this5 = this;

    var props = this.props;

    if (!props.beforeUpload) {
      // always async in case use react state to keep fileList
      return setTimeout(function () {
        return _this5.post(file);
      }, 0);
    }

    var before = props.beforeUpload(file, fileList);
    if (before && before.then) {
      before.then(function (processedFile) {
        var processedFileType = Object.prototype.toString.call(processedFile);
        if (processedFileType === '[object File]' || processedFileType === '[object Blob]') {
          _this5.post(processedFile);
        } else {
          _this5.post(file);
        }
      })['catch'](function (e) {
        console && console.log(e); // eslint-disable-line
      });
    } else if (before !== false) {
      setTimeout(function () {
        return _this5.post(file);
      }, 0);
    }
  };

  AjaxUploader.prototype.post = function post(file) {
    if (!this._isMounted) {
      return;
    }
    var props = this.props;
    var data = props.data;
    var onStart = props.onStart,
        onProgress = props.onProgress;

    if (typeof data === 'function') {
      data = data(file);
    }
    var uid = file.uid;

    var _this = this;
    this.setState({
      i: -1,
      fileData: '',
      uuidData: '',
      versionName: ''
    });
    // 文件大于0M并且满足三个接口采用分片上传
    console.log('分片', process.env.ENV_UPLOAD_FRAG);
    if (file.size > 2 * 1024 * 1024 && props.actionTesting && props.actionUpload && process.env.ENV_UPLOAD_FRAG && process.env.ENV_UPLOAD_FRAG == 'Y') {
      var request = props.customRequest || _requestget2['default'];
      var r = new FileReader();
      r.readAsBinaryString(file);
      r.onload = function (e) {
        var bolb = e.target.result;
        var md5 = (0, _jsMd2['default'])(bolb);
        var actionNew = props.actionTesting + ('?md5=' + md5 + '&fileName=' + file.name);
        _this.reqs[uid] = request({
          action: actionNew,
          filename: props.name,
          // file,
          data: data,
          headers: props.headers,
          withCredentials: props.withCredentials,
          onSuccess: function onSuccess(ret) {
            var uuid = ret.fileId;
            var versionName = ret.versionName;
            if (ret.flag === "notUploaded") {
              //没有上传过文件
              _this.UploadSlice(file, uuid, versionName);
            } else if (ret.flag === "uploading") {
              //已经上传部分
              _this.UploadSlice(file, uuid, versionName);
            } else if (ret.flag === "uploadCompleted") {
              //文件已经上传过
              props.onSuccess(ret, file, uuid);
            }
            delete _this.reqs[uid];
          },
          onError: function onError(err, ret) {
            delete _this.reqs[uid];
            props.onError(err, ret, file);
          }
        });
      };
    } else {
      var _request = props.customRequest || _request3['default'];
      _this.reqs[uid] = _request({
        action: props.action,
        filename: props.name,
        file: file,
        data: data,
        headers: props.headers,
        withCredentials: props.withCredentials,
        onProgress: onProgress ? function (e) {
          onProgress(e, file);
        } : null,
        onSuccess: function onSuccess(ret, xhr) {
          delete _this.reqs[uid];
          props.onSuccess(ret, file, xhr);
        },
        onError: function onError(err, ret) {
          delete _this.reqs[uid];
          props.onError(err, ret, file);
        }
      });
    }
    onStart(file);
  };

  AjaxUploader.prototype.reset = function reset() {
    this.setState({
      uid: (0, _uid2['default'])()
    });
  };

  AjaxUploader.prototype.abort = function abort(file) {
    this.setState({
      i: -1,
      fileData: '',
      uuidData: '',
      versionName: '',
      disabledInput: false
    });
    // const xhrs = new XMLHttpRequest();
    // xhrs.open('get', this.state.removeUrl, true);
    // xhrs.send();
    var reqs = this.reqs;

    if (file) {
      var uid = file;
      if (file && file.uid) {
        uid = file.uid;
      }
      if (reqs[uid]) {
        reqs[uid].abort();
        delete reqs[uid];
      }
    } else {
      Object.keys(reqs).forEach(function (uid) {
        if (reqs[uid]) {
          reqs[uid].abort();
        }

        delete reqs[uid];
      });
    }
  };

  AjaxUploader.prototype.render = function render() {
    var _classNames;

    var _props = this.props,
        Tag = _props.component,
        prefixCls = _props.prefixCls,
        className = _props.className,
        disabled = _props.disabled,
        style = _props.style,
        multiple = _props.multiple,
        accept = _props.accept,
        children = _props.children;

    var cls = (0, _classnames2['default'])((_classNames = {}, (0, _defineProperty3['default'])(_classNames, prefixCls, true), (0, _defineProperty3['default'])(_classNames, prefixCls + '-disabled', disabled), (0, _defineProperty3['default'])(_classNames, className, className), _classNames));
    var events = disabled ? {} : {
      onClick: this.onClick,
      onKeyDown: this.onKeyDown,
      onDrop: this.onFileDrop,
      onDragOver: this.onFileDrop,
      tabIndex: '0'
    };
    return _react2['default'].createElement(Tag, (0, _extends3['default'])({}, events, {
      className: cls,
      role: 'button',
      style: style
    }), _react2['default'].createElement('input', {
      type: 'file',
      ref: this.saveFileInput,
      key: this.state.uid,
      style: { display: 'none' },
      accept: accept,
      multiple: multiple,
      onChange: this.onChange,
      disabled: this.state.disabledInput
    }), children);
  };

  return AjaxUploader;
}(_react.Component);
/* eslint react/no-is-mounted:0 react/sort-comp:0 */

AjaxUploader.propTypes = {
  component: _propTypes2['default'].string,
  style: _propTypes2['default'].object,
  prefixCls: _propTypes2['default'].string,
  className: _propTypes2['default'].string,
  multiple: _propTypes2['default'].bool,
  disabled: _propTypes2['default'].bool,
  accept: _propTypes2['default'].string,
  children: _propTypes2['default'].any,
  onStart: _propTypes2['default'].func,
  data: _propTypes2['default'].oneOfType([_propTypes2['default'].object, _propTypes2['default'].func]),
  headers: _propTypes2['default'].object,
  beforeUpload: _propTypes2['default'].func,
  customRequest: _propTypes2['default'].func,
  onProgress: _propTypes2['default'].func,
  withCredentials: _propTypes2['default'].bool
};

exports['default'] = AjaxUploader;
module.exports = exports['default'];