'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _animate = require('../rc-components/animate');

var _animate2 = _interopRequireDefault(_animate);

var _MouseDown = require('./MouseDown');

var _MouseDown2 = _interopRequireDefault(_MouseDown);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var RippleChild = function (_React$Component) {
    (0, _inherits3['default'])(RippleChild, _React$Component);

    function RippleChild() {
        (0, _classCallCheck3['default'])(this, RippleChild);

        var _this = (0, _possibleConstructorReturn3['default'])(this, (RippleChild.__proto__ || Object.getPrototypeOf(RippleChild)).apply(this, arguments));

        _this.ripple = function (child) {
            if (React.isValidElement(child)) {
                return React.createElement(
                    _MouseDown2['default'],
                    null,
                    _this.handleMouseDown.bind(_this, child)
                );
            }
            return child;
        };
        return _this;
    }

    (0, _createClass3['default'])(RippleChild, [{
        key: 'render',
        value: function render() {
            return this.ripple(React.Children.only(this.props.children));
        }
    }, {
        key: 'handleMouseDown',
        value: function handleMouseDown(child, size) {
            var prefixCls = this.props.prefixCls;
            var _child$props = child.props,
                children = _child$props.children,
                style = _child$props.style;

            var componentProps = {
                className: prefixCls + '-wrapper'
            };
            var circle = void 0;
            if (size) {
                var x = size.x,
                    y = size.y,
                    width = size.width,
                    height = size.height;

                var maxWidth = Math.max(width - x, x);
                var maxHeight = Math.max(height - y, y);
                var max = Math.sqrt(maxWidth * maxWidth + maxHeight * maxHeight);
                this.currentCircleStyle = {
                    width: max * 2,
                    height: max * 2,
                    left: x - max,
                    top: y - max
                };
                circle = React.createElement('div', { className: prefixCls, key: 'circle', style: this.currentCircleStyle });
            }
            var newProps = {
                children: [children, React.createElement(
                    _animate2['default'],
                    { key: 'ripple', component: 'div', componentProps: componentProps, transitionName: size ? 'zoom-small-slow' : 'fade' },
                    circle
                )],
                style: this.currentStyle || style
            };
            if (size) {
                newProps.visible = 'visible';
                if (size.position === 'static') {
                    newProps.style = this.currentStyle = (0, _extends3['default'])({}, style, { position: 'relative' });
                }
            }
            return React.cloneElement(child, newProps);
        }
    }]);
    return RippleChild;
}(React.Component);

exports['default'] = RippleChild;
module.exports = exports['default'];